Subject: Re: bug#20128: 24.4; Bad regex in composition-function-table hangs Emacs

From: Lars Ingebrigtsen <[email-masked]>
Date: Fri, 02 Aug 2019 14:35:55 +0200

Richard Wordingham <[email-masked]> writes:

> Loading an Emacs lisp file (e.g. by load-file in .emacs) containing the
> commands:
>
> (defvar tai-tham-composable-pattern
>   (let ((table
> 	 '(
> 	   ("C" . "[\u1A20-\u1A54") ; Missing ']'!
> 	   ("M" . "[\u1A55-\u1A5E\u1A61-\u1A7C\u1A7F]"); Mark
> 	   ("H" . "\u1A60") ; sakot
> 	   ("N" . "\u1A58"))) ; mai kang lai
> 	(regexp "C\\(M|HC\\)*\\(NC\\(M|HC\\)*\\)*N?"))
>     (let ((case-fold-search nil))
>       (dolist (elt table)
> 	(setq regexp (replace-regexp-in-string (car elt) (cdr elt)
> 					       regexp t t))))
>     regexp))
>
> (let ((elt (list (vector tai-tham-composable-pattern 0
> 'font-shape-gstring)
>                  (vector "." 0 'font-shape-gstring) )))
>   (set-char-table-range composition-function-table '(#x1A20 . #x1AAD)
> elt))
>
> causes Emacs to hang when a character in the range U+1A20 to U+1AAD
> needs to be rendered.  Now, the value of tai-tham-composable-pattern is
> an unbalanced regex, so that may be the cause of the problem.

(I'm going through old bug reports that unfortunately have not received
any responses yet.)

I don't think you can reasonably expect Emacs to work properly when you
have put invalid regexps into a function like that, so I'm closing this
bug as a "wontfix".

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no